$ORIGIN {{ sutty }}.
$TTL {{ dns_ttl }}

; The Start Of Authority sets information for replication.  Every node
; is going to be its own authority, so the information for replication is
; mostly unneeded, unless we start delegating to other providers.  In this
; case the delegation should be to one of the nodes.  For instance, to
; delegate zones to dns.he.net, we'd add a delegation to athshe, and then
; to delegate to freedns.afraid.org, we'd add a delegation to
; anarres.sutty.nl.  The expire information is kept intentionally low
; because our strategy is for each node to provide their own IP addresses
; in the A* records, so when they're down, the information goes away with
; them.  If we had a typical, hierarchical setup, we'd want them high so
; if the authoritative server is down, the delegates keep serving the
; information.
{{ sutty }}. IN SOA {{ inventory_hostname }}. {{ inventory_hostname }}. ( {{ ansible_managed }} {{ soa_ttl }} {{ soa_ttl }} {{ soa_ttl }} {{ soa_ttl }} );

; The glue allows to solve nameservers located on the same domain.  They
; are added on the registrar side but we put them here to not forget
; they're needed.
{% for node in groups.sutty_dns %}
ns{{ loop.index }} IN A {{ hostvars[node].ansible_host }}
ns{{ groups.sutty_dns | length() + loop.index }} IN A {{ hostvars[node].ansible_host }}
{{ node }}. IN A {{ hostvars[node].ansible_host }}
{{ node }}. IN NS {{ node }}.
{% endfor %}

; Nameservers.  Each node is its own nameserver. A DNS resolver is going
; to pick one of these at random.
{% for node in groups.sutty_dns %}
@ IN NS {{ node }}.
{% endfor %}

; A* Records. Here we just make the node publish its own IP addresses,
; so when they're down, the IP address goes away with them.  This way we
; don't have to monitor node status to update the DNS information
; accordingly.
@ IN A {{ ansible_host }}

; Email servers.  Since email servers can retry and find other servers,
; if a server is down, incoming email will arrive at one or the other.  If
; all nodes are up, incoming email is distributed between them.
{% for node in groups.sutty_email %}
@ IN MX 1 {{ node }}.
{% endfor %}
@ IN TXT "v=spf1 mx -all"
_dmarc IN TXT "v=DMARC1; p={{ dmarc_policy }}; rua=mailto:rua@{{ sutty }}; ruf=mailto:ruf@{{ sutty }}"
_domainkey IN A {{ ansible_host }}
_domainkey IN NS _domainkey
_mta-sts IN TXT "v=STSv1; id={{ ansible_managed }}"
_smtp._tls IN TXT "v=TLSRPTv1; rua=mailto:tlsrpt@{{ sutty }}"

; Certificate issuing
@ IN CAA 0 issue "letsencrypt.org"

; Certificate Validation Delegate.  This node is delegated with issuing certificates."
{% for node in groups.sutty_certbot %}
_acme-challenge IN A {{ hostvars[node].ansible_host }}
_acme-challenge IN NS _acme-challenge
{% endfor %}

; Distributed Press
_dnslink IN NS api.distributed.press.

{% for reserved in reserved_info %}
; {{ reserved.comment }}
{% for record in reserved.records %}
{{ reserved.name }} IN {{ record.type }} {{ record.value }}
{% endfor %}
{% endfor %}

; SSH server fingerprints.
{% for node in groups.sutty_dns %}
{% for ssh_fingerprint in hostvars[node]['ssh_fingerprints'] %}
{{ ssh_fingerprint }}
{% endfor %}
{% endfor %}
